diff -NurpP --minimal linux-2.6.18/arch/s390/kernel/process.c linux-2.6.18-vs2.1.1-rc37/arch/s390/kernel/process.c
--- linux-2.6.18/arch/s390/kernel/process.c	2006-09-20 16:58:01 +0200
+++ linux-2.6.18-vs2.1.1-rc37/arch/s390/kernel/process.c	2006-09-25 15:40:02 +0200
@@ -165,9 +165,9 @@ void show_regs(struct pt_regs *regs)
 	struct task_struct *tsk = current;
 
         printk("CPU:    %d    %s\n", task_thread_info(tsk)->cpu, print_tainted());
-        printk("Process %s (pid: %d, task: %p, ksp: %p)\n",
-	       current->comm, current->pid, (void *) tsk,
-	       (void *) tsk->thread.ksp);
+	printk("Process %s (pid: %d[#%u], task: %p, ksp: %p)\n",
+	       current->comm, current->pid, current->xid,
+	       (void *) tsk, (void *) tsk->thread.ksp);
 
 	show_registers(regs);
 	/* Show stack backtrace if pt_regs is from kernel mode */
@@ -197,7 +197,7 @@ int kernel_thread(int (*fn)(void *), voi
 	regs.orig_gpr2 = -1;
 
 	/* Ok, create the new process.. */
-	return do_fork(flags | CLONE_VM | CLONE_UNTRACED,
+	return do_fork(flags | CLONE_VM | CLONE_UNTRACED | CLONE_KTHREAD,
 		       0, &regs, 0, NULL, NULL);
 }
 
diff -NurpP --minimal linux-2.6.18/arch/s390/kernel/ptrace.c linux-2.6.18-vs2.1.1-rc37/arch/s390/kernel/ptrace.c
--- linux-2.6.18/arch/s390/kernel/ptrace.c	2006-06-18 04:52:33 +0200
+++ linux-2.6.18-vs2.1.1-rc37/arch/s390/kernel/ptrace.c	2006-09-25 15:40:02 +0200
@@ -723,7 +723,13 @@ sys_ptrace(long request, long pid, long 
 		goto out;
 	}
 
+	if (!vx_check(vx_task_xid(child), VX_WATCH_P|VX_IDENT)) {
+		ret = -EPERM;
+		goto out_tsk;
+	}
+
 	ret = do_ptrace(child, request, addr, data);
+out_tsk:
 	put_task_struct(child);
 out:
 	unlock_kernel();
diff -NurpP --minimal linux-2.6.18/arch/s390/kernel/syscalls.S linux-2.6.18-vs2.1.1-rc37/arch/s390/kernel/syscalls.S
--- linux-2.6.18/arch/s390/kernel/syscalls.S	2006-06-18 04:52:33 +0200
+++ linux-2.6.18-vs2.1.1-rc37/arch/s390/kernel/syscalls.S	2006-09-20 17:01:44 +0200
@@ -271,7 +271,7 @@ SYSCALL(sys_clock_settime,sys_clock_sett
 SYSCALL(sys_clock_gettime,sys_clock_gettime,sys32_clock_gettime_wrapper)	/* 260 */
 SYSCALL(sys_clock_getres,sys_clock_getres,sys32_clock_getres_wrapper)
 SYSCALL(sys_clock_nanosleep,sys_clock_nanosleep,sys32_clock_nanosleep_wrapper)
-NI_SYSCALL							/* reserved for vserver */
+SYSCALL(sys_vserver,sys_vserver,sys32_vserver)
 SYSCALL(s390_fadvise64_64,sys_ni_syscall,sys32_fadvise64_64_wrapper)
 SYSCALL(sys_statfs64,sys_statfs64,compat_sys_statfs64_wrapper)
 SYSCALL(sys_fstatfs64,sys_fstatfs64,compat_sys_fstatfs64_wrapper)
diff -NurpP --minimal linux-2.6.18/arch/sh/Kconfig linux-2.6.18-vs2.1.1-rc37/arch/sh/Kconfig
--- linux-2.6.18/arch/sh/Kconfig	2006-09-20 16:58:01 +0200
+++ linux-2.6.18-vs2.1.1-rc37/arch/sh/Kconfig	2006-09-20 17:01:44 +0200
@@ -646,6 +646,8 @@ source "arch/sh/oprofile/Kconfig"
 
 source "arch/sh/Kconfig.debug"
 
+source "kernel/vserver/Kconfig"
+
 source "security/Kconfig"
 
 source "crypto/Kconfig"
diff -NurpP --minimal linux-2.6.18/arch/sh/kernel/kgdb_stub.c linux-2.6.18-vs2.1.1-rc37/arch/sh/kernel/kgdb_stub.c
--- linux-2.6.18/arch/sh/kernel/kgdb_stub.c	2004-08-14 12:54:51 +0200
+++ linux-2.6.18-vs2.1.1-rc37/arch/sh/kernel/kgdb_stub.c	2006-09-20 17:01:44 +0200
@@ -412,7 +412,7 @@ static struct task_struct *get_thread(in
 	if (pid == PID_MAX) pid = 0;
 
 	/* First check via PID */
-	thread = find_task_by_pid(pid);
+	thread = find_task_by_real_pid(pid);
 
 	if (thread)
 		return thread;
diff -NurpP --minimal linux-2.6.18/arch/sh/kernel/process.c linux-2.6.18-vs2.1.1-rc37/arch/sh/kernel/process.c
--- linux-2.6.18/arch/sh/kernel/process.c	2006-06-18 04:52:33 +0200
+++ linux-2.6.18-vs2.1.1-rc37/arch/sh/kernel/process.c	2006-09-25 15:40:02 +0200
@@ -112,7 +112,8 @@ void machine_power_off(void)
 void show_regs(struct pt_regs * regs)
 {
 	printk("\n");
-	printk("Pid : %d, Comm: %20s\n", current->pid, current->comm);
+	printk("Pid : %d[#%u], Comm: %20s\n",
+		current->pid, current->xid, current->comm);
 	print_symbol("PC is at %s\n", regs->pc);
 	printk("PC  : %08lx SP  : %08lx SR  : %08lx ",
 	       regs->pc, regs->regs[15], regs->sr);
@@ -180,7 +181,8 @@ int kernel_thread(int (*fn)(void *), voi
 	regs.sr = (1 << 30);
 
 	/* Ok, create the new process.. */
-	return do_fork(flags | CLONE_VM | CLONE_UNTRACED, 0, &regs, 0, NULL, NULL);
+	return do_fork(flags | CLONE_VM | CLONE_UNTRACED | CLONE_KTHREAD,
+		0, &regs, 0, NULL, NULL);
 }
 
 /*
diff -NurpP --minimal linux-2.6.18/arch/sh/kernel/setup.c linux-2.6.18-vs2.1.1-rc37/arch/sh/kernel/setup.c
--- linux-2.6.18/arch/sh/kernel/setup.c	2006-09-20 16:58:01 +0200
+++ linux-2.6.18-vs2.1.1-rc37/arch/sh/kernel/setup.c	2006-09-20 17:01:44 +0200
@@ -21,6 +21,7 @@
 #include <linux/utsname.h>
 #include <linux/cpu.h>
 #include <linux/pfn.h>
+#include <linux/vs_cvirt.h>
 #include <asm/uaccess.h>
 #include <asm/io.h>
 #include <asm/sections.h>
@@ -481,7 +482,7 @@ static int show_cpuinfo(struct seq_file 
 		seq_printf(m, "machine\t\t: %s\n", get_system_type());
 
 	seq_printf(m, "processor\t: %d\n", cpu);
-	seq_printf(m, "cpu family\t: %s\n", system_utsname.machine);
+	seq_printf(m, "cpu family\t: %s\n", vx_new_uts(machine));
 	seq_printf(m, "cpu type\t: %s\n", get_cpu_subtype());
 
 	show_cpuflags(m);
diff -NurpP --minimal linux-2.6.18/arch/sh/kernel/sys_sh.c linux-2.6.18-vs2.1.1-rc37/arch/sh/kernel/sys_sh.c
--- linux-2.6.18/arch/sh/kernel/sys_sh.c	2005-08-29 22:24:55 +0200
+++ linux-2.6.18-vs2.1.1-rc37/arch/sh/kernel/sys_sh.c	2006-09-20 17:01:44 +0200
@@ -21,6 +21,7 @@
 #include <linux/mman.h>
 #include <linux/file.h>
 #include <linux/utsname.h>
+#include <linux/vs_cvirt.h>
 
 #include <asm/uaccess.h>
 #include <asm/ipc.h>
@@ -267,7 +268,7 @@ asmlinkage int sys_uname(struct old_utsn
 	if (!name)
 		return -EFAULT;
 	down_read(&uts_sem);
-	err=copy_to_user(name, &system_utsname, sizeof (*name));
+	err=copy_to_user(name, vx_new_utsname(), sizeof (*name));
 	up_read(&uts_sem);
 	return err?-EFAULT:0;
 }
diff -NurpP --minimal linux-2.6.18/arch/sh64/kernel/process.c linux-2.6.18-vs2.1.1-rc37/arch/sh64/kernel/process.c
--- linux-2.6.18/arch/sh64/kernel/process.c	2006-09-20 16:58:01 +0200
+++ linux-2.6.18-vs2.1.1-rc37/arch/sh64/kernel/process.c	2006-09-25 15:40:02 +0200
@@ -639,7 +639,7 @@ int kernel_thread(int (*fn)(void *), voi
 static __inline__ _syscall2(int,clone,unsigned long,flags,unsigned long,newsp)
 static __inline__ _syscall1(int,exit,int,ret)
 
-	reply = clone(flags | CLONE_VM, 0);
+	reply = clone(flags | CLONE_VM | CLONE_KTHREAD, 0);
 	if (!reply) {
 		/* Child */
 		reply = exit(fn(arg));
diff -NurpP --minimal linux-2.6.18/arch/sh64/kernel/sys_sh64.c linux-2.6.18-vs2.1.1-rc37/arch/sh64/kernel/sys_sh64.c
--- linux-2.6.18/arch/sh64/kernel/sys_sh64.c	2005-06-22 02:37:59 +0200
+++ linux-2.6.18-vs2.1.1-rc37/arch/sh64/kernel/sys_sh64.c	2006-09-20 17:01:44 +0200
@@ -29,6 +29,7 @@
 #include <linux/file.h>
 #include <linux/utsname.h>
 #include <linux/syscalls.h>
+#include <linux/vs_cvirt.h>
 #include <asm/uaccess.h>
 #include <asm/ipc.h>
 #include <asm/ptrace.h>
@@ -279,7 +280,7 @@ asmlinkage int sys_uname(struct old_utsn
 	if (!name)
 		return -EFAULT;
 	down_read(&uts_sem);
-	err=copy_to_user(name, &system_utsname, sizeof (*name));
+	err=copy_to_user(name, vx_new_utsname(), sizeof (*name));
 	up_read(&uts_sem);
 	return err?-EFAULT:0;
 }
diff -NurpP --minimal linux-2.6.18/arch/sparc/Kconfig linux-2.6.18-vs2.1.1-rc37/arch/sparc/Kconfig
--- linux-2.6.18/arch/sparc/Kconfig	2006-06-18 04:52:33 +0200
+++ linux-2.6.18-vs2.1.1-rc37/arch/sparc/Kconfig	2006-09-20 17:01:44 +0200
@@ -291,6 +291,8 @@ source "fs/Kconfig"
 
 source "arch/sparc/Kconfig.debug"
 
+source "kernel/vserver/Kconfig"
+
 source "security/Kconfig"
 
 source "crypto/Kconfig"
diff -NurpP --minimal linux-2.6.18/arch/sparc/kernel/process.c linux-2.6.18-vs2.1.1-rc37/arch/sparc/kernel/process.c
--- linux-2.6.18/arch/sparc/kernel/process.c	2006-09-20 16:58:01 +0200
+++ linux-2.6.18-vs2.1.1-rc37/arch/sparc/kernel/process.c	2006-09-25 15:40:02 +0200
@@ -705,7 +705,8 @@ pid_t kernel_thread(int (*fn)(void *), v
 			     /* Notreached by child. */
 			     "1: mov %%o0, %0\n\t" :
 			     "=r" (retval) :
-			     "i" (__NR_clone), "r" (flags | CLONE_VM | CLONE_UNTRACED),
+			     "i" (__NR_clone), "r" (flags |
+					CLONE_VM | CLONE_UNTRACED | CLONE_KTHREAD),
 			     "i" (__NR_exit),  "r" (fn), "r" (arg) :
 			     "g1", "g2", "g3", "o0", "o1", "memory", "cc");
 	return retval;
diff -NurpP --minimal linux-2.6.18/arch/sparc/kernel/ptrace.c linux-2.6.18-vs2.1.1-rc37/arch/sparc/kernel/ptrace.c
--- linux-2.6.18/arch/sparc/kernel/ptrace.c	2006-04-09 13:49:44 +0200
+++ linux-2.6.18-vs2.1.1-rc37/arch/sparc/kernel/ptrace.c	2006-10-06 23:10:42 +0200
@@ -299,6 +299,10 @@ asmlinkage void do_ptrace(struct pt_regs
 		pt_error_return(regs, -ret);
 		goto out;
 	}
+	if (!vx_check(vx_task_xid(child), VX_WATCH_P|VX_IDENT)) {
+		pt_error_return(regs, ESRCH);
+		goto out_tsk;
+	}
 
 	if ((current->personality == PER_SUNOS && request == PTRACE_SUNATTACH)
 	    || (current->personality != PER_SUNOS && request == PTRACE_ATTACH)) {
diff -NurpP --minimal linux-2.6.18/arch/sparc/kernel/sys_sparc.c linux-2.6.18-vs2.1.1-rc37/arch/sparc/kernel/sys_sparc.c
--- linux-2.6.18/arch/sparc/kernel/sys_sparc.c	2006-09-20 16:58:04 +0200
+++ linux-2.6.18-vs2.1.1-rc37/arch/sparc/kernel/sys_sparc.c	2006-09-20 19:57:58 +0200
@@ -21,6 +21,7 @@
 #include <linux/utsname.h>
 #include <linux/smp.h>
 #include <linux/smp_lock.h>
+#include <linux/vs_cvirt.h>
 
 #include <asm/uaccess.h>
 #include <asm/ipc.h>
@@ -475,13 +476,13 @@ asmlinkage int sys_getdomainname(char __
 
  	down_read(&uts_sem);
  	
-	nlen = strlen(system_utsname.domainname) + 1;
+	nlen = strlen(vx_new_uts(domainname)) + 1;
 	err = -EINVAL;
 	if (nlen > len)
 		goto out;
 
 	err = -EFAULT;
-	if (!copy_to_user(name, system_utsname.domainname, nlen))
+	if (!copy_to_user(name, vx_new_uts(domainname), nlen))
 		err = 0;
 
 out:
diff -NurpP --minimal linux-2.6.18/arch/sparc/kernel/sys_sunos.c linux-2.6.18-vs2.1.1-rc37/arch/sparc/kernel/sys_sunos.c
--- linux-2.6.18/arch/sparc/kernel/sys_sunos.c	2006-09-20 16:58:06 +0200
+++ linux-2.6.18-vs2.1.1-rc37/arch/sparc/kernel/sys_sunos.c	2006-09-20 17:01:44 +0200
@@ -35,6 +35,7 @@
 #include <linux/smp.h>
 #include <linux/smp_lock.h>
 #include <linux/syscalls.h>
+#include <linux/vs_cvirt.h>
 
 #include <net/sock.h>
 
@@ -482,14 +483,16 @@ struct sunos_utsname {
 asmlinkage int sunos_uname(struct sunos_utsname __user *name)
 {
 	int ret;
+	struct new_utsname *ptr;
 	down_read(&uts_sem);
-	ret = copy_to_user(&name->sname[0], &system_utsname.sysname[0], sizeof(name->sname) - 1);
+	ptr = vx_new_utsname();
+	ret = copy_to_user(&name->sname[0], ptr->sysname, sizeof(name->sname) - 1);
 	if (!ret) {
-		ret |= __copy_to_user(&name->nname[0], &system_utsname.nodename[0], sizeof(name->nname) - 1);
+		ret |= __copy_to_user(&name->nname[0], ptr->nodename, sizeof(name->nname) - 1);
 		ret |= __put_user('\0', &name->nname[8]);
-		ret |= __copy_to_user(&name->rel[0], &system_utsname.release[0], sizeof(name->rel) - 1);
-		ret |= __copy_to_user(&name->ver[0], &system_utsname.version[0], sizeof(name->ver) - 1);
-		ret |= __copy_to_user(&name->mach[0], &system_utsname.machine[0], sizeof(name->mach) - 1);
+		ret |= __copy_to_user(&name->rel[0], ptr->release, sizeof(name->rel) - 1);
+		ret |= __copy_to_user(&name->ver[0], ptr->version, sizeof(name->ver) - 1);
+		ret |= __copy_to_user(&name->mach[0], ptr->machine, sizeof(name->mach) - 1);
 	}
 	up_read(&uts_sem);
 	return ret ? -EFAULT : 0;
diff -NurpP --minimal linux-2.6.18/arch/sparc/kernel/systbls.S linux-2.6.18-vs2.1.1-rc37/arch/sparc/kernel/systbls.S
--- linux-2.6.18/arch/sparc/kernel/systbls.S	2006-09-20 16:58:06 +0200
+++ linux-2.6.18-vs2.1.1-rc37/arch/sparc/kernel/systbls.S	2006-09-20 17:01:44 +0200
@@ -71,7 +71,7 @@ sys_call_table:
 /*250*/	.long sparc_mremap, sys_sysctl, sys_getsid, sys_fdatasync, sys_nfsservctl
 /*255*/	.long sys_sync_file_range, sys_clock_settime, sys_clock_gettime, sys_clock_getres, sys_clock_nanosleep
 /*260*/	.long sys_sched_getaffinity, sys_sched_setaffinity, sys_timer_settime, sys_timer_gettime, sys_timer_getoverrun
-/*265*/	.long sys_timer_delete, sys_timer_create, sys_nis_syscall, sys_io_setup, sys_io_destroy
+/*265*/	.long sys_timer_delete, sys_timer_create, sys_vserver, sys_io_setup, sys_io_destroy
 /*270*/	.long sys_io_submit, sys_io_cancel, sys_io_getevents, sys_mq_open, sys_mq_unlink
 /*275*/	.long sys_mq_timedsend, sys_mq_timedreceive, sys_mq_notify, sys_mq_getsetattr, sys_waitid
 /*280*/	.long sys_tee, sys_add_key, sys_request_key, sys_keyctl, sys_openat
diff -NurpP --minimal linux-2.6.18/arch/sparc/kernel/traps.c linux-2.6.18-vs2.1.1-rc37/arch/sparc/kernel/traps.c
--- linux-2.6.18/arch/sparc/kernel/traps.c	2006-09-20 16:58:06 +0200
+++ linux-2.6.18-vs2.1.1-rc37/arch/sparc/kernel/traps.c	2006-09-25 15:40:02 +0200
@@ -99,7 +99,8 @@ void die_if_kernel(char *str, struct pt_
 "              /_| \\__/ |_\\\n"
 "                 \\__U_/\n");
 
-	printk("%s(%d): %s [#%d]\n", current->comm, current->pid, str, ++die_counter);
+	printk("%s(%d[#%u]): %s [#%d]\n", current->comm,
+		current->pid, current->xid, str, ++die_counter);
 	show_regs(regs);
 
 	__SAVE; __SAVE; __SAVE; __SAVE;
diff -NurpP --minimal linux-2.6.18/arch/sparc64/Kconfig linux-2.6.18-vs2.1.1-rc37/arch/sparc64/Kconfig
--- linux-2.6.18/arch/sparc64/Kconfig	2006-09-20 16:58:06 +0200
+++ linux-2.6.18-vs2.1.1-rc37/arch/sparc64/Kconfig	2006-09-20 17:01:44 +0200
@@ -431,6 +431,8 @@ endmenu
 
 source "arch/sparc64/Kconfig.debug"
 
+source "kernel/vserver/Kconfig"
+
 source "security/Kconfig"
 
 source "crypto/Kconfig"
diff -NurpP --minimal linux-2.6.18/arch/sparc64/kernel/binfmt_aout32.c linux-2.6.18-vs2.1.1-rc37/arch/sparc64/kernel/binfmt_aout32.c
--- linux-2.6.18/arch/sparc64/kernel/binfmt_aout32.c	2006-06-18 04:52:34 +0200
+++ linux-2.6.18-vs2.1.1-rc37/arch/sparc64/kernel/binfmt_aout32.c	2006-09-20 17:01:44 +0200
@@ -27,6 +27,7 @@
 #include <linux/binfmts.h>
 #include <linux/personality.h>
 #include <linux/init.h>
+#include <linux/vs_memory.h>
 
 #include <asm/system.h>
 #include <asm/uaccess.h>
diff -NurpP --minimal linux-2.6.18/arch/sparc64/kernel/process.c linux-2.6.18-vs2.1.1-rc37/arch/sparc64/kernel/process.c
--- linux-2.6.18/arch/sparc64/kernel/process.c	2006-09-20 16:58:06 +0200
+++ linux-2.6.18-vs2.1.1-rc37/arch/sparc64/kernel/process.c	2006-09-25 15:40:02 +0200
@@ -696,7 +696,8 @@ pid_t kernel_thread(int (*fn)(void *), v
 			     /* Notreached by child. */
 			     "1:" :
 			     "=r" (retval) :
-			     "i" (__NR_clone), "r" (flags | CLONE_VM | CLONE_UNTRACED),
+			     "i" (__NR_clone), "r" (flags |
+				CLONE_VM | CLONE_UNTRACED | CLONE_KTHREAD),
 			     "i" (__NR_exit),  "r" (fn), "r" (arg) :
 			     "g1", "g2", "g3", "o0", "o1", "memory", "cc");
 	return retval;
diff -NurpP --minimal linux-2.6.18/arch/sparc64/kernel/ptrace.c linux-2.6.18-vs2.1.1-rc37/arch/sparc64/kernel/ptrace.c
--- linux-2.6.18/arch/sparc64/kernel/ptrace.c	2006-06-18 04:52:35 +0200
+++ linux-2.6.18-vs2.1.1-rc37/arch/sparc64/kernel/ptrace.c	2006-10-06 23:10:42 +0200
@@ -212,6 +212,10 @@ asmlinkage void do_ptrace(struct pt_regs
 		pt_error_return(regs, -ret);
 		goto out;
 	}
+	if (!vx_check(vx_task_xid(child), VX_WATCH_P|VX_IDENT)) {
+		pt_error_return(regs, ESRCH);
+		goto out_tsk;
+	}
 
 	if ((current->personality == PER_SUNOS && request == PTRACE_SUNATTACH)
 	    || (current->personality != PER_SUNOS && request == PTRACE_ATTACH)) {
diff -NurpP --minimal linux-2.6.18/arch/sparc64/kernel/sys_sparc.c linux-2.6.18-vs2.1.1-rc37/arch/sparc64/kernel/sys_sparc.c
--- linux-2.6.18/arch/sparc64/kernel/sys_sparc.c	2006-09-20 16:58:06 +0200
+++ linux-2.6.18-vs2.1.1-rc37/arch/sparc64/kernel/sys_sparc.c	2006-09-20 19:57:05 +0200
@@ -25,6 +25,7 @@
 #include <linux/ipc.h>
 #include <linux/personality.h>
 #include <linux/random.h>
+#include <linux/vs_cvirt.h>
 
 #include <asm/uaccess.h>
 #include <asm/ipc.h>
@@ -712,13 +713,13 @@ asmlinkage long sys_getdomainname(char _
 
  	down_read(&uts_sem);
  	
-	nlen = strlen(system_utsname.domainname) + 1;
+	nlen = strlen(vx_new_uts(domainname)) + 1;
 	err = -EINVAL;
 	if (nlen > len)
 		goto out;
 
 	err = -EFAULT;
-	if (!copy_to_user(name, system_utsname.domainname, nlen))
+	if (!copy_to_user(name, vx_new_uts(domainname), nlen))
 		err = 0;
 
 out:
diff -NurpP --minimal linux-2.6.18/arch/sparc64/kernel/sys_sparc32.c linux-2.6.18-vs2.1.1-rc37/arch/sparc64/kernel/sys_sparc32.c
--- linux-2.6.18/arch/sparc64/kernel/sys_sparc32.c	2006-09-20 16:58:06 +0200
+++ linux-2.6.18-vs2.1.1-rc37/arch/sparc64/kernel/sys_sparc32.c	2006-09-25 15:40:02 +0200
@@ -787,7 +787,7 @@ asmlinkage long sys32_gettimeofday(struc
 {
 	if (tv) {
 		struct timeval ktv;
-		do_gettimeofday(&ktv);
+		vx_gettimeofday(&ktv);
 		if (put_tv32(tv, &ktv))
 			return -EFAULT;
 	}
diff -NurpP --minimal linux-2.6.18/arch/sparc64/kernel/sys_sunos32.c linux-2.6.18-vs2.1.1-rc37/arch/sparc64/kernel/sys_sunos32.c
--- linux-2.6.18/arch/sparc64/kernel/sys_sunos32.c	2006-09-20 16:58:06 +0200
+++ linux-2.6.18-vs2.1.1-rc37/arch/sparc64/kernel/sys_sunos32.c	2006-09-20 17:01:44 +0200
@@ -35,6 +35,7 @@
 #include <linux/smp.h>
 #include <linux/smp_lock.h>
 #include <linux/syscalls.h>
+#include <linux/vs_cvirt.h>
 
 #include <asm/uaccess.h>
 #include <asm/page.h>
@@ -437,18 +438,20 @@ struct sunos_utsname {
 asmlinkage int sunos_uname(struct sunos_utsname __user *name)
 {
 	int ret;
+	struct new_utsname *ptr;
 
 	down_read(&uts_sem);
-	ret = copy_to_user(&name->sname[0], &system_utsname.sysname[0],
+	ptr = vx_new_utsname();
+	ret = copy_to_user(&name->sname[0], ptr->sysname,
 			   sizeof(name->sname) - 1);
-	ret |= copy_to_user(&name->nname[0], &system_utsname.nodename[0],
+	ret |= copy_to_user(&name->nname[0], ptr->nodename,
 			    sizeof(name->nname) - 1);
 	ret |= put_user('\0', &name->nname[8]);
-	ret |= copy_to_user(&name->rel[0], &system_utsname.release[0],
+	ret |= copy_to_user(&name->rel[0], ptr->release,
 			    sizeof(name->rel) - 1);
-	ret |= copy_to_user(&name->ver[0], &system_utsname.version[0],
+	ret |= copy_to_user(&name->ver[0], ptr->version,
 			    sizeof(name->ver) - 1);
-	ret |= copy_to_user(&name->mach[0], &system_utsname.machine[0],
+	ret |= copy_to_user(&name->mach[0], ptr->machine,
 			    sizeof(name->mach) - 1);
 	up_read(&uts_sem);
 	return (ret ? -EFAULT : 0);
diff -NurpP --minimal linux-2.6.18/arch/sparc64/kernel/systbls.S linux-2.6.18-vs2.1.1-rc37/arch/sparc64/kernel/systbls.S
--- linux-2.6.18/arch/sparc64/kernel/systbls.S	2006-09-20 16:58:06 +0200
+++ linux-2.6.18-vs2.1.1-rc37/arch/sparc64/kernel/systbls.S	2006-09-20 17:01:44 +0200
@@ -72,7 +72,7 @@ sys_call_table32:
 /*250*/	.word sys32_mremap, sys32_sysctl, sys32_getsid, sys_fdatasync, sys32_nfsservctl
 	.word sys32_sync_file_range, compat_sys_clock_settime, compat_sys_clock_gettime, compat_sys_clock_getres, sys32_clock_nanosleep
 /*260*/	.word compat_sys_sched_getaffinity, compat_sys_sched_setaffinity, sys32_timer_settime, compat_sys_timer_gettime, sys_timer_getoverrun
-	.word sys_timer_delete, compat_sys_timer_create, sys_ni_syscall, compat_sys_io_setup, sys_io_destroy
+	.word sys_timer_delete, compat_sys_timer_create, sys32_vserver, compat_sys_io_setup, sys_io_destroy
 /*270*/	.word sys32_io_submit, sys_io_cancel, compat_sys_io_getevents, sys32_mq_open, sys_mq_unlink
 	.word compat_sys_mq_timedsend, compat_sys_mq_timedreceive, compat_sys_mq_notify, compat_sys_mq_getsetattr, compat_sys_waitid
 /*280*/	.word sys32_tee, sys_add_key, sys_request_key, sys_keyctl, compat_sys_openat
@@ -142,7 +142,7 @@ sys_call_table:
 /*250*/	.word sys64_mremap, sys_sysctl, sys_getsid, sys_fdatasync, sys_nfsservctl
 	.word sys_sync_file_range, sys_clock_settime, sys_clock_gettime, sys_clock_getres, sys_clock_nanosleep
 /*260*/	.word sys_sched_getaffinity, sys_sched_setaffinity, sys_timer_settime, sys_timer_gettime, sys_timer_getoverrun
-	.word sys_timer_delete, sys_timer_create, sys_ni_syscall, sys_io_setup, sys_io_destroy
+	.word sys_timer_delete, sys_timer_create, sys_vserver, sys_io_setup, sys_io_destroy
 /*270*/	.word sys_io_submit, sys_io_cancel, sys_io_getevents, sys_mq_open, sys_mq_unlink
 	.word sys_mq_timedsend, sys_mq_timedreceive, sys_mq_notify, sys_mq_getsetattr, sys_waitid
 /*280*/	.word sys_tee, sys_add_key, sys_request_key, sys_keyctl, sys_openat
diff -NurpP --minimal linux-2.6.18/arch/sparc64/kernel/traps.c linux-2.6.18-vs2.1.1-rc37/arch/sparc64/kernel/traps.c
--- linux-2.6.18/arch/sparc64/kernel/traps.c	2006-09-20 16:58:06 +0200
+++ linux-2.6.18-vs2.1.1-rc37/arch/sparc64/kernel/traps.c	2006-09-25 15:40:02 +0200
@@ -2215,7 +2215,8 @@ void die_if_kernel(char *str, struct pt_
 "              /_| \\__/ |_\\\n"
 "                 \\__U_/\n");
 
-	printk("%s(%d): %s [#%d]\n", current->comm, current->pid, str, ++die_counter);
+	printk("%s(%d[#%u]): %s [#%d]\n", current->comm,
+		current->pid, current->xid, str, ++die_counter);
 	notify_die(DIE_OOPS, str, regs, 0, 255, SIGSEGV);
 	__asm__ __volatile__("flushw");
 	__show_regs(regs);
diff -NurpP --minimal linux-2.6.18/arch/sparc64/solaris/fs.c linux-2.6.18-vs2.1.1-rc37/arch/sparc64/solaris/fs.c
--- linux-2.6.18/arch/sparc64/solaris/fs.c	2006-09-20 16:58:06 +0200
+++ linux-2.6.18-vs2.1.1-rc37/arch/sparc64/solaris/fs.c	2006-09-20 17:01:44 +0200
@@ -363,7 +363,7 @@ static int report_statvfs(struct vfsmoun
 		int j = strlen (p);
 		
 		if (j > 15) j = 15;
-		if (IS_RDONLY(inode)) i = 1;
+		if (IS_RDONLY(inode) || MNT_IS_RDONLY(mnt)) i = 1;
 		if (mnt->mnt_flags & MNT_NOSUID) i |= 2;
 		if (!sysv_valid_dev(inode->i_sb->s_dev))
 			return -EOVERFLOW;
@@ -399,7 +399,7 @@ static int report_statvfs64(struct vfsmo
 		int j = strlen (p);
 		
 		if (j > 15) j = 15;
-		if (IS_RDONLY(inode)) i = 1;
+		if (IS_RDONLY(inode) || MNT_IS_RDONLY(mnt)) i = 1;
 		if (mnt->mnt_flags & MNT_NOSUID) i |= 2;
 		if (!sysv_valid_dev(inode->i_sb->s_dev))
 			return -EOVERFLOW;
diff -NurpP --minimal linux-2.6.18/arch/sparc64/solaris/misc.c linux-2.6.18-vs2.1.1-rc37/arch/sparc64/solaris/misc.c
--- linux-2.6.18/arch/sparc64/solaris/misc.c	2006-09-20 16:58:06 +0200
+++ linux-2.6.18-vs2.1.1-rc37/arch/sparc64/solaris/misc.c	2006-09-20 17:01:44 +0200
@@ -16,6 +16,7 @@
 #include <linux/timex.h>
 #include <linux/major.h>
 #include <linux/compat.h>
+#include <linux/vs_cvirt.h>
 
 #include <asm/uaccess.h>
 #include <asm/string.h>
@@ -248,7 +249,7 @@ asmlinkage int solaris_utssys(u32 buf, u
 		/* Let's cheat */
 		err  = set_utsfield(v->sysname, "SunOS", 1, 0);
 		down_read(&uts_sem);
-		err |= set_utsfield(v->nodename, system_utsname.nodename,
+		err |= set_utsfield(v->nodename, vx_new_uts(nodename),
 				    1, 1);
 		up_read(&uts_sem);
 		err |= set_utsfield(v->release, "2.6", 0, 0);
@@ -272,7 +273,7 @@ asmlinkage int solaris_utsname(u32 buf)
 	/* Why should we not lie a bit? */
 	down_read(&uts_sem);
 	err  = set_utsfield(v->sysname, "SunOS", 0, 0);
-	err |= set_utsfield(v->nodename, system_utsname.nodename, 1, 1);
+	err |= set_utsfield(v->nodename, vx_new_uts(nodename), 1, 1);
 	err |= set_utsfield(v->release, "5.6", 0, 0);
 	err |= set_utsfield(v->version, "Generic", 0, 0);
 	err |= set_utsfield(v->machine, machine(), 0, 0);
@@ -304,7 +305,7 @@ asmlinkage int solaris_sysinfo(int cmd, 
 	case SI_HOSTNAME:
 		r = buffer + 256;
 		down_read(&uts_sem);
-		for (p = system_utsname.nodename, q = buffer; 
+		for (p = vx_new_uts(nodename), q = buffer;
 		     q < r && *p && *p != '.'; *q++ = *p++);
 		up_read(&uts_sem);
 		*q = 0;
diff -NurpP --minimal linux-2.6.18/arch/um/Kconfig linux-2.6.18-vs2.1.1-rc37/arch/um/Kconfig
--- linux-2.6.18/arch/um/Kconfig	2006-06-18 04:52:36 +0200
+++ linux-2.6.18-vs2.1.1-rc37/arch/um/Kconfig	2006-09-20 17:01:44 +0200
@@ -279,6 +279,8 @@ source "drivers/connector/Kconfig"
 
 source "fs/Kconfig"
 
+source "kernel/vserver/Kconfig"
+
 source "security/Kconfig"
 
 source "crypto/Kconfig"
diff -NurpP --minimal linux-2.6.18/arch/um/kernel/process_kern.c linux-2.6.18-vs2.1.1-rc37/arch/um/kernel/process_kern.c
--- linux-2.6.18/arch/um/kernel/process_kern.c	2006-06-18 04:52:38 +0200
+++ linux-2.6.18-vs2.1.1-rc37/arch/um/kernel/process_kern.c	2006-10-06 23:10:42 +0200
@@ -23,6 +23,7 @@
 #include "linux/proc_fs.h"
 #include "linux/ptrace.h"
 #include "linux/random.h"
+
 #include "asm/unistd.h"
 #include "asm/mman.h"
 #include "asm/segment.h"
@@ -95,7 +96,7 @@ int kernel_thread(int (*fn)(void *), voi
 
 	current->thread.request.u.thread.proc = fn;
 	current->thread.request.u.thread.arg = arg;
-	pid = do_fork(CLONE_VM | CLONE_UNTRACED | flags, 0,
+	pid = do_fork(CLONE_VM | CLONE_UNTRACED | CLONE_KTHREAD | flags, 0,
 		      &current->thread.regs, 0, NULL, NULL);
 	if(pid < 0)
 		panic("do_fork failed in kernel_thread, errno = %d", pid);
diff -NurpP --minimal linux-2.6.18/arch/um/kernel/syscall.c linux-2.6.18-vs2.1.1-rc37/arch/um/kernel/syscall.c
--- linux-2.6.18/arch/um/kernel/syscall.c	2006-09-20 16:58:06 +0200
+++ linux-2.6.18-vs2.1.1-rc37/arch/um/kernel/syscall.c	2006-09-21 16:41:49 +0200
@@ -15,6 +15,8 @@
 #include "linux/unistd.h"
 #include "linux/slab.h"
 #include "linux/utime.h"
+#include <linux/vs_cvirt.h>
+
 #include "asm/mman.h"
 #include "asm/uaccess.h"
 #include "kern_util.h"
@@ -110,7 +112,7 @@ long sys_uname(struct old_utsname __user
 	if (!name)
 		return -EFAULT;
 	down_read(&uts_sem);
-	err = copy_to_user(name, &system_utsname, sizeof (*name));
+	err = copy_to_user(name, vx_new_utsname(), sizeof (*name));
 	up_read(&uts_sem);
 	return err?-EFAULT:0;
 }
@@ -118,6 +120,7 @@ long sys_uname(struct old_utsname __user
 long sys_olduname(struct oldold_utsname __user * name)
 {
 	long error;
+	struct new_utsname *ptr;
 
 	if (!name)
 		return -EFAULT;
@@ -126,19 +129,20 @@ long sys_olduname(struct oldold_utsname 
 
   	down_read(&uts_sem);
 
-	error = __copy_to_user(&name->sysname,&system_utsname.sysname,
+	ptr = vx_new_utsname();
+	error = __copy_to_user(&name->sysname,ptr->sysname,
 			       __OLD_UTS_LEN);
 	error |= __put_user(0,name->sysname+__OLD_UTS_LEN);
-	error |= __copy_to_user(&name->nodename,&system_utsname.nodename,
+	error |= __copy_to_user(&name->nodename,ptr->nodename,
 				__OLD_UTS_LEN);
 	error |= __put_user(0,name->nodename+__OLD_UTS_LEN);
-	error |= __copy_to_user(&name->release,&system_utsname.release,
+	error |= __copy_to_user(&name->release,ptr->release,
 				__OLD_UTS_LEN);
 	error |= __put_user(0,name->release+__OLD_UTS_LEN);
-	error |= __copy_to_user(&name->version,&system_utsname.version,
+	error |= __copy_to_user(&name->version,ptr->version,
 				__OLD_UTS_LEN);
 	error |= __put_user(0,name->version+__OLD_UTS_LEN);
-	error |= __copy_to_user(&name->machine,&system_utsname.machine,
+	error |= __copy_to_user(&name->machine,ptr->machine,
 				__OLD_UTS_LEN);
 	error |= __put_user(0,name->machine+__OLD_UTS_LEN);
 
diff -NurpP --minimal linux-2.6.18/arch/um/sys-x86_64/syscalls.c linux-2.6.18-vs2.1.1-rc37/arch/um/sys-x86_64/syscalls.c
--- linux-2.6.18/arch/um/sys-x86_64/syscalls.c	2006-06-18 04:52:42 +0200
+++ linux-2.6.18-vs2.1.1-rc37/arch/um/sys-x86_64/syscalls.c	2006-09-20 17:01:44 +0200
@@ -9,6 +9,7 @@
 #include "linux/shm.h"
 #include "linux/utsname.h"
 #include "linux/personality.h"
+#include "linux/vs_cvirt.h"
 #include "asm/uaccess.h"
 #define __FRAME_OFFSETS
 #include "asm/ptrace.h"
@@ -21,7 +22,7 @@ asmlinkage long sys_uname64(struct new_u
 {
 	int err;
 	down_read(&uts_sem);
-	err = copy_to_user(name, &system_utsname, sizeof (*name));
+	err = copy_to_user(name, vx_new_utsname(), sizeof (*name));
 	up_read(&uts_sem);
 	if (personality(current->personality) == PER_LINUX32)
 		err |= copy_to_user(&name->machine, "i686", 5);
diff -NurpP --minimal linux-2.6.18/arch/v850/Kconfig linux-2.6.18-vs2.1.1-rc37/arch/v850/Kconfig
--- linux-2.6.18/arch/v850/Kconfig	2006-06-18 04:52:42 +0200
+++ linux-2.6.18-vs2.1.1-rc37/arch/v850/Kconfig	2006-09-20 17:01:44 +0200
@@ -326,6 +326,8 @@ source "drivers/usb/Kconfig"
 
 source "arch/v850/Kconfig.debug"
 
+source "kernel/vserver/Kconfig"
+
 source "security/Kconfig"
 
 source "crypto/Kconfig"
diff -NurpP --minimal linux-2.6.18/arch/v850/kernel/process.c linux-2.6.18-vs2.1.1-rc37/arch/v850/kernel/process.c
--- linux-2.6.18/arch/v850/kernel/process.c	2006-09-20 16:58:06 +0200
+++ linux-2.6.18-vs2.1.1-rc37/arch/v850/kernel/process.c	2006-09-25 15:40:02 +0200
@@ -83,7 +83,7 @@ int kernel_thread (int (*fn)(void *), vo
 	/* Clone this thread.  Note that we don't pass the clone syscall's
 	   second argument -- it's ignored for calls from kernel mode (the
 	   child's SP is always set to the top of the kernel stack).  */
-	arg0 = flags | CLONE_VM;
+	arg0 = flags | CLONE_VM | CLONE_KTHREAD;
 	syscall = __NR_clone;
 	asm volatile ("trap " SYSCALL_SHORT_TRAP
 		      : "=r" (ret), "=r" (syscall)
diff -NurpP --minimal linux-2.6.18/arch/v850/kernel/ptrace.c linux-2.6.18-vs2.1.1-rc37/arch/v850/kernel/ptrace.c
--- linux-2.6.18/arch/v850/kernel/ptrace.c	2006-04-09 13:49:44 +0200
+++ linux-2.6.18-vs2.1.1-rc37/arch/v850/kernel/ptrace.c	2006-09-25 15:40:02 +0200
@@ -117,6 +117,9 @@ long arch_ptrace(struct task_struct *chi
 {
 	int rval;
 
+	if (!vx_check(vx_task_xid(child), VX_WATCH_P|VX_IDENT))
+		goto out;
+
 	switch (request) {
 		unsigned long val, copied;
 
diff -NurpP --minimal linux-2.6.18/arch/x86_64/Kconfig linux-2.6.18-vs2.1.1-rc37/arch/x86_64/Kconfig
--- linux-2.6.18/arch/x86_64/Kconfig	2006-09-20 16:58:06 +0200
+++ linux-2.6.18-vs2.1.1-rc37/arch/x86_64/Kconfig	2006-09-20 17:01:44 +0200
@@ -654,6 +654,8 @@ endmenu
 
 source "arch/x86_64/Kconfig.debug"
 
+source "kernel/vserver/Kconfig"
+
 source "security/Kconfig"
 
 source "crypto/Kconfig"
diff -NurpP --minimal linux-2.6.18/arch/x86_64/ia32/ia32_aout.c linux-2.6.18-vs2.1.1-rc37/arch/x86_64/ia32/ia32_aout.c
--- linux-2.6.18/arch/x86_64/ia32/ia32_aout.c	2006-01-03 17:29:20 +0100
+++ linux-2.6.18-vs2.1.1-rc37/arch/x86_64/ia32/ia32_aout.c	2006-09-20 17:01:44 +0200
@@ -25,6 +25,7 @@
 #include <linux/binfmts.h>
 #include <linux/personality.h>
 #include <linux/init.h>
+#include <linux/vs_memory.h>
 
 #include <asm/system.h>
 #include <asm/uaccess.h>
diff -NurpP --minimal linux-2.6.18/arch/x86_64/ia32/ia32_binfmt.c linux-2.6.18-vs2.1.1-rc37/arch/x86_64/ia32/ia32_binfmt.c
--- linux-2.6.18/arch/x86_64/ia32/ia32_binfmt.c	2006-09-20 16:58:06 +0200
+++ linux-2.6.18-vs2.1.1-rc37/arch/x86_64/ia32/ia32_binfmt.c	2006-09-20 17:01:44 +0200
@@ -376,7 +376,8 @@ int ia32_setup_arg_pages(struct linux_bi
 			kmem_cache_free(vm_area_cachep, mpnt);
 			return ret;
 		}
-		mm->stack_vm = mm->total_vm = vma_pages(mpnt);
+		vx_vmpages_sub(mm, mm->total_vm - vma_pages(mpnt));
+		mm->stack_vm = mm->total_vm;
 	} 
 
 	for (i = 0 ; i < MAX_ARG_PAGES ; i++) {
diff -NurpP --minimal linux-2.6.18/arch/x86_64/ia32/ia32entry.S linux-2.6.18-vs2.1.1-rc37/arch/x86_64/ia32/ia32entry.S
--- linux-2.6.18/arch/x86_64/ia32/ia32entry.S	2006-09-20 16:58:06 +0200
+++ linux-2.6.18-vs2.1.1-rc37/arch/x86_64/ia32/ia32entry.S	2006-09-20 17:01:44 +0200
@@ -668,7 +668,7 @@ ia32_sys_call_table:
 	.quad sys_tgkill		/* 270 */
 	.quad compat_sys_utimes
 	.quad sys32_fadvise64_64
-	.quad quiet_ni_syscall	/* sys_vserver */
+	.quad sys32_vserver
 	.quad sys_mbind
 	.quad compat_sys_get_mempolicy	/* 275 */
 	.quad sys_set_mempolicy
